{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //losttype:{routeName:'LostType-getComboValues',table:'lost_types',limit:250}
            //,losttypeG:{routeName:'LostType-getComboValues',table:'lost_types',limit:250}
        },
        rendererrepeattype:function(val){
            if(val=='none') return "{{ 'Offtime.repeattype_none'|trans }}";
            if(val=='day') return "{{ 'Offtime.repeattype_day'|trans }}";
            //if(val=='week') return "{{ 'Offtime.repeattype_week'|trans }}";
            return '';
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.stores.repeattypes=new mj.store({
                data:[{id:'none',code:"{{ 'Offtime.repeattype_none'|trans }}"}
                    ,{id:'day',code:"{{ 'Offtime.repeattype_day'|trans }}"}
                    //,{id:'week',code:"{{ 'Offtime.repeattype_week'|trans }}"}
                ]
            });
            t.stores.repeattypesG=new mj.store({
                data:[{id:'none',code:"{{ 'Offtime.repeattype_none'|trans }}"}
                    ,{id:'day',code:"{{ 'Offtime.repeattype_day'|trans }}"}
                    //,{id:'week',code:"{{ 'Offtime.repeattype_week'|trans }}"}
                ]
            });
            t.checks = {};
	        t.stationData = {};
            const gridConfig = {
                cm: [
                    {header: "{{ 'Offtime.losttype'|trans }}", dataIndex: 'losttype', width: 150,filter:'single',type:'combo',store:t.extras.lost_types,alias:'o',operator:'='},
                    {header: "{{ 'Offtime.name'|trans }}", dataIndex: 'name', width: 150,filter:'between',alias:'o'},
                    {header: "{{ 'Offtime.repeattype'|trans }}", dataIndex: 'repeattype', width: 100,filter:'single', type:'combo',store:t.stores.repeattypesG,alias:'o',operator:'=',renderer:t.rendererrepeattype},
                    {header: "{{ 'Offtime.startday'|trans }}", dataIndex: 'startday', width: 90,filter:'between',type:'date',alias:'o'},
                    {header: "{{ 'Offtime.starttime'|trans }}", dataIndex: 'starttime', width: 90,alias:'o',operator:'='},
                    //{header: "{{ 'Offtime.finishday'|trans }}", dataIndex: 'finishday', width: 90,alias:'o',operator:'='},
                    {header: "{{ 'Offtime.finishtime'|trans }}", dataIndex: 'finishtime', width: 80,filter:'between', type:'date',alias:'o'},
                    {header: "{{ 'Offtime.clearonovertimeGrid'|trans }}", dataIndex: 'clearonovertime', width: 80,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'o'}
                ]
            };

            t._setGridConfig(gridConfig);
            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : "{{ 'Offtime.clients'|trans }}",
                        labelWidth : '110px',
                        width : 170,
                        height : 320
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 600,
                        height : 320,
                        style : 'position:absolute;top:0px;left:210px;',
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.combo({
                                title: "{{ 'Offtime.losttype'|trans }}",
                                placeHolder: "{{ 'Offtime.losttype'|trans }}",
                                dataIndex: 'losttype',
                                labelWidth : '110px',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                notEmpty: true,
                                grid: 's12 m6',
                                width: 200,
                                store: t.extras.lost_types
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.clearonovertime'|trans }}",
                                dataIndex: 'clearonovertime',
                                labelWidth : '120px',
                                grid: 'none',
                                right:true
                            }),
                            new mj.form.textField({
                                title: "{{ 'Offtime.name'|trans }}",
                                dataIndex: 'name',
                                maxLength: 255,
                                labelWidth : '110px',
                                width:300,
                                grid: 's4 m2'
                            }),
                            new mj.form.combo({
                                title: "{{ 'Offtime.repeattype'|trans }}",
                                placeHolder: "{{ 'Offtime.repeattype'|trans }}",
                                dataIndex: 'repeattype',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                sameValueDisplay:false,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                width: 150,
                                store: t.stores.repeattypes
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.daySMonday'|trans }}",
                                dataIndex: 'Monday',
                                itemStyle: 'padding:0 20px 0 0;float:left;',
                                labelWidth : '40px',
                                grid: 'none'
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.daySTuesday'|trans }}",
                                dataIndex: 'Tuesday',
                                itemStyle: 'padding:0 20px 0 0;float:left;',
                                labelWidth : '40px',
                                grid: 'none',
                                right:true
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.daySWednesday'|trans }}",
                                dataIndex: 'Wednesday',
                                itemStyle: 'padding:0 20px 0 0;float:left;',
                                labelWidth : '40px',
                                grid: 'none',
                                right:true
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.daySThursday'|trans }}",
                                dataIndex: 'Thursday',
                                itemStyle: 'padding:0 20px 0 0;float:left;',
                                labelWidth : '40px',
                                grid: 'none',
                                right:true
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.daySFriday'|trans }}",
                                dataIndex: 'Friday',
                                itemStyle: 'padding:0 20px 0 0;float:left;',
                                labelWidth : '40px',
                                grid: 'none',
                                right:true
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.daySSaturday'|trans }}",
                                dataIndex: 'Saturday',
                                itemStyle: 'padding:0 20px 0 0;float:left;',
                                labelWidth : '40px',
                                grid: 'none',
                                right:true
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'Offtime.daySSunday'|trans }}",
                                dataIndex: 'Sunday',
                                itemStyle: 'padding:0 20px 0 0;float:left;',
                                labelWidth : '40px',
                                grid: 'none',
                                right:true
                            }),
                            new mj.form.dateField({
                                title : "{{ 'Offtime.startday'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'startday',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.timeField({
                                title: "{{ 'Offtime.starttime'|trans }}",
                                dataIndex: 'starttime',
                                labelWidth : '110px',
                                notEmpty: true,
                                grid: 's4 m2',
                                width:40
                            }),
                            //new mj.form.dateField({
                            //    title : "{{ 'Offtime.finishday'|trans }}",
                            //    labelWidth : '110px',
                            //    dataIndex : 'finishday',
                            //    width : 80,
                            //    notEmpty : true
                            //}),
                            new mj.form.timeField({
                                title: "{{ 'Offtime.finishtime'|trans }}",
                                dataIndex: 'finishtime',
                                labelWidth : '110px',
                                notEmpty: true,
                                grid: 's4 m2',
                                width:40,
                                right:true
                            }),
                            new mj.form.dateField({
                                title: "{{ 'Offtime.start'|trans }}",
                                dataIndex: 'start',
                                labelWidth : '110px',
                                width : 80,
                                notEmpty: true,
                                grid: 's4 m2'
                            }),
                            new mj.form.dateField({
                                title: "{{ 'Offtime.finish'|trans }}",
                                dataIndex: 'finish',
                                labelWidth : '110px',
                                width : 80,
                                grid: 's4 m2'
                            })
                        ]
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);

            t.buttons.selectNone = t.forms.main.addButton({
                alt: "{{ 'Offtime.selectNone'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox',
                scope: t,
                handler: function(){
                    t.checker(0);
                }
            });
            t.buttons.selectAll = t.forms.main.addButton({
                alt: "{{ 'Offtime.selectAll'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox-checked',
                scope: t,
                handler: function(){
                    t.checker(1);
                }
            });

            t.len=t.forms.main.items.length;
            
            for(var i = 0,l = t.extras.clients.length;i<l;i++){
                if(t.forms.main.items.getIndex('id','client_' + t.extras.clients[i].code) === -1){
                    t.forms.main.add(
                        new mj.form.checkBox({
                            title : t.extras.clients[i].code,
                            id : 'client_' + t.extras.clients[i].code,
                            labelWidth : '130px',
                            labelPos : 'right',
                            dataIndex : 'client'/*,
                            checked : st.data[i].checked*/
                        }),'f1'
                    );
                }
            }
            t.checks.client = t.forms.main.items[0].items;
            //t.tabPanels.main.setActive(0);
        },
        checker : function(v){
            var t=this;
            var bi = t.forms.main.items[0].items;
            for(var i=0;i<bi.length;i++){
                bi[i].setValue(v);
            }
        },
        editSelectedRecord: function(){
            var t=this;
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false){
                t.editData(selectedRecord);
                var s = selectedRecord.clients.split("|");
                i=-1;
                var f;
                while(++i<s.length){
                    f = 'client_'+s[i];
                    var fi = t.forms.main.getField(f);
                    if(fi)
                        fi.setValue(1);
                }
            }
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var clients="";
                    var flag=false;
                    for(var i = 0 , l = t.checks.client.length;i<l;i++){
                        if(t.checks.client[i].checked){
                            flag=true;
                            id = t.checks.client[i].id.replace('client_','');
                            clients=(clients==""?id:clients+"|"+id);
                        }
                    }
                    if(flag){
                        var data = f.getValue();
                        if(data.repeattype==''||data.repeattype==null){
                            t.messageShow(t,mj.lng.glb.error,"{{ 'Offtime.errRepeatTypeNotSelected'|trans }}");
                            return;
                        }
                        data.clients=clients;
                        data.days='';
                        if(data.repeattype!=='none'){
                            if(data.Monday===true){
                                data.days+=(data.days==""?'Monday':"|Monday");
                            }
                            if(data.Tuesday===true){
                                data.days+=(data.days==""?'Tuesday':"|Tuesday");
                            }
                            if(data.Wednesday===true){
                                data.days+=(data.days==""?'Wednesday':"|Wednesday");
                            }
                            if(data.Thursday===true){
                                data.days+=(data.days==""?'Thursday':"|Thursday");
                            }
                            if(data.Friday===true){
                                data.days+=(data.days==""?'Friday':"|Friday");
                            }
                            if(data.Saturday===true){
                                data.days+=(data.days==""?'Saturday':"|Saturday");
                            }
                            if(data.Sunday===true){
                                data.days+=(data.days==""?'Sunday':"|Sunday");
                            }
                            delete data.startday;
                            delete data.finishday;
                        }
                        delete data.client;
                        delete data.Monday;
                        delete data.Tuesday;
                        delete data.Wednesday;
                        delete data.Thursday;
                        delete data.Friday;
                        delete data.Saturday;
                        delete data.Sunday;
                        if(data.repeattype=='day'&&data.days==''){
                            t.messageShow(t,mj.lng.glb.error,"{{ 'Offtime.errDayNotSelected'|trans }}");
                            return;
                        }
                        t.waitMaskShow();
                        var id = f.getValue('id').id;
                        var versionField = f.getField('version');
                        var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                        var mode = id ? 'update' : 'add';
                        var routeName = f.modulename + '-' + mode;
                        var route = Routing.getRoute(routeName);
                        var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                            'pg': t.grids.main.pbar.current,
                            'lm': t.grids.main.pbar.limit
                        } : {'pg':1,'lm':25};
                        var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                            'id': id,
                            'v': version
                        }) : pagerParams);
                        
                        data.menuId = t.id;
                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                            t.waitMaskShow();
                            t._event='save';
                            $.ajax({
                                url: url,
                                method: "POST",
                                headers: { 
                                    "Content-Type": "application/json",
                                    "X-HTTP-Method-Override": route.methods[0] 
                                },
                                data: JSON.stringify(data),
                                dataType: 'json',
		                        success: function(data, textStatus, xhr) {
                                    t.reset(_f, data);
                                },
                                error: function(xhr, textStatus, errorThrown) {
                                    t.waitMaskHide();
                                    if(xhr.responseJSON&&xhr.responseJSON.message){
                                        mj.message({
                                            title: mj.lng.glb.error,
                                            msg: xhr.responseJSON.message,
                                            type: "error",
                                            html: true
                                        });
                                    }
                                },
                                complete: function(jqXHR, textStatus) {
                                    //t.waitMaskHide();
                                }
                            });
                        }
                    }else{
                        //t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                        t.messageShow(t,mj.lng.glb.error,"{{ 'Offtime.errClientNotSelected'|trans }}");
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
